"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: !0
}), exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends")), _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty")), _react = _interopRequireDefault(require("react")), _reactDom = _interopRequireDefault(require("react-dom")), _propTypes = _interopRequireDefault(require("prop-types")), _reactDraggable = _interopRequireDefault(require("react-draggable")), _createReactClass = _interopRequireDefault(require("create-react-class")), _rayAnimate = _interopRequireDefault(require("ray-animate")), _rayHotkeys = require("ray-hotkeys"), _LazyRenderBox = _interopRequireDefault(require("./LazyRenderBox"));

function ownKeys(e, t) {
  var r = Object.keys(e);
  if (Object.getOwnPropertySymbols) {
    var o = Object.getOwnPropertySymbols(e);
    t && (o = o.filter((function(t) {
      return Object.getOwnPropertyDescriptor(e, t).enumerable;
    }))), r.push.apply(r, o);
  }
  return r;
}

function _objectSpread(e) {
  for (var t = 1; t < arguments.length; t++) {
    var r = null != arguments[t] ? arguments[t] : {};
    t % 2 ? ownKeys(Object(r), !0).forEach((function(t) {
      (0, _defineProperty2.default)(e, t, r[t]);
    })) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(r)) : ownKeys(Object(r)).forEach((function(t) {
      Object.defineProperty(e, t, Object.getOwnPropertyDescriptor(r, t));
    }));
  }
  return e;
}

var uuid = 0, openCount = 0, scrollbarMeasure = {
  position: "absolute",
  top: "-9999px",
  width: "50px",
  height: "50px",
  overflow: "scroll"
};

function noop() {}

function getScroll(e, t) {
  var r = e["page".concat(t ? "Y" : "X", "Offset")], o = "scroll".concat(t ? "Top" : "Left");
  if ("number" != typeof r) {
    var a = e.document;
    "number" != typeof (r = a.documentElement[o]) && (r = a.body[o]);
  }
  return r;
}

function setTransformOrigin(e, t) {
  var r = e.style;
  [ "Webkit", "Moz", "Ms", "ms" ].forEach((function(e) {
    r["".concat(e, "TransformOrigin")] = t;
  })), r.transformOrigin = t;
}

function offset(e) {
  var t = e.getBoundingClientRect(), r = {
    left: t.left,
    top: t.top
  }, o = e.ownerDocument, a = o.defaultView || o.parentWindow;
  return r.left += getScroll(a), r.top += getScroll(a, 1), r;
}

var _dragableOps = {
  axis: "both",
  defaultPosition: {
    x: 0,
    y: 0
  },
  position: null,
  grid: [ 25, 25 ],
  zIndex: 100
}, Dialog = (0, _createReactClass.default)({
  displayName: "Dialog",
  propTypes: {
    onAfterClose: _propTypes.default.func,
    onClose: _propTypes.default.func,
    closable: _propTypes.default.bool,
    maskClosable: _propTypes.default.bool,
    visible: _propTypes.default.bool,
    mousePosition: _propTypes.default.object,
    wrapStyle: _propTypes.default.object,
    prefixCls: _propTypes.default.string,
    wrapClassName: _propTypes.default.string,
    dragable: _propTypes.default.bool,
    dragableOps: _propTypes.default.object
  },
  getDefaultProps: function() {
    return {
      onAfterClose: noop,
      onClose: noop,
      dragable: !1,
      dragableOps: _dragableOps
    };
  },
  componentWillMount: function() {
    this.titleId = "rcDialogTitle".concat(uuid++);
  },
  componentDidMount: function() {
    this.componentDidUpdate({});
  },
  componentDidUpdate: function(e) {
    var t = this.props, r = this.props.mousePosition;
    if (t.visible) {
      if (!e.visible) {
        this.lastOutSideFocusNode = document.activeElement, this.addScrollingEffect(), this.refs.wrap.focus();
        var o = _reactDom.default.findDOMNode(this.refs.dialog);
        if (r) {
          var a = offset(o);
          setTransformOrigin(o, "".concat(r.x - a.left, "px ").concat(r.y - a.top, "px"));
        } else setTransformOrigin(o, "");
      }
    } else if (e.visible && t.mask && this.lastOutSideFocusNode) {
      try {
        this.lastOutSideFocusNode.focus();
      } catch (e) {
        this.lastOutSideFocusNode = null;
      }
      this.lastOutSideFocusNode = null;
    }
  },
  onAnimateLeave: function() {
    this.refs.wrap && (this.refs.wrap.style.display = "none"), this.removeScrollingEffect(), 
    this.props.onAfterClose();
  },
  onMaskClick: function(e) {
    e.target === e.currentTarget && this.props.closable && this.props.maskClosable && this.close(e);
  },
  onKeyDown: function(e) {
    var t = this.props;
    if (t.closable && t.keyboard && e.keyCode === _rayHotkeys.KeyCode.ESC && this.close(e), 
    t.visible && e.keyCode === _rayHotkeys.KeyCode.TAB) {
      var r = document.activeElement, o = this.refs.wrap, a = this.refs.sentinel;
      e.shiftKey ? r === o && a.focus() : r === this.refs.sentinel && o.focus();
    }
  },
  getDialogElement: function() {
    var e, t, r, o = this.props, a = o.closable, i = o.prefixCls, n = {};
    void 0 !== o.width && (n.width = o.width), void 0 !== o.height && (n.height = o.height), 
    o.footer && (e = _react.default.createElement("div", {
      className: "".concat(i, "-footer"),
      ref: "footer"
    }, o.footer)), o.title && (t = _react.default.createElement("div", {
      className: "".concat(i, "-header"),
      ref: "header"
    }, _react.default.createElement("div", {
      className: "".concat(i, "-title"),
      id: this.titleId
    }, o.title))), a && (r = _react.default.createElement("button", {
      onClick: this.close,
      "aria-label": "Close",
      className: "".concat(i, "-close")
    }, _react.default.createElement("span", {
      className: "".concat(i, "-close-x")
    })));
    var s = _objectSpread(_objectSpread({}, o.style), n), l = this.getTransitionName(), c = (0, 
    _extends2.default)({}, _dragableOps, o.dragableOps), d = _react.default.createElement("div", {
      className: "".concat(i, "-content")
    }, r, t, _react.default.createElement("div", {
      className: "".concat(i, "-body"),
      style: o.bodyStyle,
      ref: "body"
    }, o.children), e), u = _react.default.createElement(_LazyRenderBox.default, {
      role: "document",
      ref: "dialog",
      style: s,
      className: "".concat(i, " ").concat(o.className || ""),
      visible: o.visible
    }, o.dragable ? _react.default.createElement(_reactDraggable.default, c, d) : d, _react.default.createElement("div", {
      tabIndex: "0",
      ref: "sentinel",
      style: {
        width: 0,
        height: 0,
        overflow: "hidden"
      }
    }, "sentinel"));
    return _react.default.createElement(_rayAnimate.default, {
      key: "dialog",
      showProp: "visible",
      onLeave: this.onAnimateLeave,
      transitionName: l,
      component: "",
      transitionAppear: !0
    }, u);
  },
  getZIndexStyle: function() {
    var e = {}, t = this.props;
    return void 0 !== t.zIndex && (e.zIndex = t.zIndex), e;
  },
  getWrapStyle: function() {
    return (0, _extends2.default)({}, this.getZIndexStyle(), this.props.wrapStyle);
  },
  getMaskElement: function() {
    var e, t = this.props;
    if (t.mask) {
      var r = this.getMaskTransitionName();
      e = _react.default.createElement(_LazyRenderBox.default, {
        style: this.getZIndexStyle(),
        key: "mask",
        className: "".concat(t.prefixCls, "-mask"),
        hiddenClassName: "".concat(t.prefixCls, "-mask-hidden"),
        visible: t.visible
      }), r && (e = _react.default.createElement(_rayAnimate.default, {
        key: "mask",
        showProp: "visible",
        transitionAppear: !0,
        component: "",
        transitionName: r
      }, e));
    }
    return e;
  },
  getMaskTransitionName: function() {
    var e = this.props, t = e.maskTransitionName, r = e.maskAnimation;
    return !t && r && (t = "".concat(e.prefixCls, "-").concat(r)), t;
  },
  getTransitionName: function() {
    var e = this.props, t = e.transitionName, r = e.animation;
    return !t && r && (t = "".concat(e.prefixCls, "-").concat(r)), t;
  },
  getElement: function(e) {
    return this.refs[e];
  },
  setScrollbar: function() {
    this.bodyIsOverflowing && this.scrollbarWidth && (document.body.style.paddingRight = "".concat(this.scrollbarWidth, "px"));
  },
  addScrollingEffect: function() {
    1 === ++openCount && (this.checkScrollbar(), this.setScrollbar(), document.body.style.overflow = "hidden");
  },
  removeScrollingEffect: function() {
    0 === --openCount && (document.body.style.overflow = "", this.resetScrollbar());
  },
  close: function(e) {
    this.props.onClose(e);
  },
  checkScrollbar: function() {
    var e = window.innerWidth;
    if (!e) {
      var t = document.documentElement.getBoundingClientRect();
      e = t.right - Math.abs(t.left);
    }
    this.bodyIsOverflowing = document.body.clientWidth < e, this.bodyIsOverflowing && (this.scrollbarWidth = this.measureScrollbar());
  },
  resetScrollbar: function() {
    document.body.style.paddingRight = "";
  },
  measureScrollbar: function() {
    if (void 0 !== this.scrollbarWidth) return this.scrollbarWidth;
    var e = document.createElement("div");
    for (var t in scrollbarMeasure) scrollbarMeasure.hasOwnProperty(t) && (e.style[t] = scrollbarMeasure[t]);
    document.body.appendChild(e);
    var r = e.offsetWidth - e.clientWidth;
    return document.body.removeChild(e), this.scrollbarWidth = r, r;
  },
  adjustDialog: function() {
    if (this.refs.wrap && this.scrollbarWidth) {
      var e = this.refs.wrap.scrollHeight > document.documentElement.clientHeight;
      this.refs.wrap.style.paddingLeft = "".concat(!this.bodyIsOverflowing && e ? this.scrollbarWidth : "", "px"), 
      this.refs.wrap.style.paddingRight = "".concat(this.bodyIsOverflowing && !e ? this.scrollbarWidth : "", "px");
    }
  },
  resetAdjustments: function() {
    this.refs.wrap && (this.refs.wrap.style.paddingLeft = this.refs.wrap.style.paddingLeft = "");
  },
  render: function() {
    var e = this.props, t = e.prefixCls, r = this.getWrapStyle();
    return e.visible && (r.display = null), _react.default.createElement("div", null, this.getMaskElement(), _react.default.createElement("div", {
      tabIndex: "-1",
      onKeyDown: this.onKeyDown,
      className: "".concat(t, "-wrap ").concat(e.wrapClassName || ""),
      ref: "wrap",
      onClick: this.onMaskClick,
      role: "dialog",
      "aria-labelledby": e.title ? this.titleId : null,
      style: r
    }, this.getDialogElement()));
  }
}), _default = Dialog;

exports.default = _default;